#ifndef MISC_H
#define MISC_H

#include <qvaluelist.h>
#include <qstringlist.h>
#include "../libgadu/lib/libgadu.h"

#define __c2q(__char_pointer__) QString::fromLocal8Bit(__char_pointer__)

class UserList;

extern UserList userlist;
extern struct config config;

class UinsList : public QValueList<uin_t>
{
	public:
		UinsList();
		bool equals(UinsList &uins);
		void sort();
};

struct colors {
    int userboxBgR;
    int userboxBgG;
    int userboxBgB;
    int userboxFgR;
    int userboxFgG;
    int userboxFgB;
};

struct config {
	uin_t uin;
	char *password;
	QString nick;
	char *soundmsg;
	char *soundchat;
	char *soundprog;
	double soundvol;
	bool soundvolctrl;
	bool playartsdsp;
	bool playsound;
	bool logmessages;
	bool savegeometry;
	bool playsoundchat;
	bool playsoundchatinvisible;
	int defaultstatus;
	QString defaultdescription;
	int sysmsgidx;
	bool allowdcc;
	char *dccip;
	char *extip;
	int extport;
	char *server;
	bool dock;
	bool privatestatus;
	bool rundocked;
	bool grouptabs;
	QRect geometry;

	char * smsapp;
	bool smscustomconf;
	char * smsconf;

	bool emoticons;
	char *emoticonspath;
	bool autosend;
	bool scrolldown;
	int chatprunelen;
	bool chatprune;
	bool msgacks;

	bool autoaway;
	int autoawaytime;

	QStringList notifies;
	char *soundnotify;
	bool notifyglobal;
	bool notifydialog;
	bool notifysound;

	bool useproxy;
	char * proxyaddr;
	unsigned short proxyport;

	bool raise;

	struct colors colors;
	QString userboxFont;
	int userboxFontSize;
	QString chatFont;
	int chatFontSize;
};

struct groups {
  int number;
  char * name;
};

char* preparePath(char* filename);
void cp_to_iso(unsigned char *buf);
void iso_to_cp(unsigned char *buf);
void loadKaduConfig(void);
void saveKaduConfig(void);
char *pwHash(const char *tekst);

#endif
